
int iterations = 200;

float min_x = -5.5;
float max_x =5.5;

float min_y = -5.5;
float max_y = 5.5;

int w = 1400;
int h = 1400;

float step_x;
float step_y;

double epsilon     = 0.00000000001;
double big_epsilon = epsilon * 1000;

void setup() { 
  size(w,h);
  background(255,255,255);
  
  step_x = (max_x - min_x) / (float) w;
  step_y = (max_y - min_y) / (float) h;
   fill(0,0,0);      
   line(0,0,0,h-1);
   line(0,0,w-1,0);
   line(w-1,0,w-1,h-1);
   line(0,h-1,w-1,h-1);

    PFont metaBold = loadFont("AlBayan-8.vlw");
textFont(metaBold); 
//textMode(SCREEN);


    int x = 10;
    int y= 25;
    for(y=25;y<h-5;y+=25) {
      
      Point p = to_logic(new Point(x,y));
      /*if(abs(p.y)<0.01) {  
        stroke(60,60,60);
        line(0,y,w-1,y);
        stroke(0,0,0);
      }*/
      line(0,y,5,y);
      line(w-6,y,w-1,y);
      text(String.format("%.2f",p.y),x,y+3);
    }  
    
    y= 15;
    for(x=25;x<w-10;x+=25) {
      line(x,0,x,5);
      line(x,h-6,x,h-1);
      Point p = to_logic(new Point(x,y));
   /*   if(abs(p.x)<0.01) {
        stroke(60,60,60);
        line(x,0,x,h-1);
        stroke(0,0,0);
      }*/ 
      text(String.format("%.2f",p.x),x,y);
    } 
}


class Point {
  public float x;
  public float y;
  
  public Point(float x, float y) {
    this.x=x; this.y=y;
  }
  
  public float len() {
    return sqrt(x*x + y*y);
  }
  

  }
  
  
/*Point F(Point p) {
  return new Point( 
        0.5 * p.x * p.x + 0.5 * p.y - cos (p.x) + cos(p.y),
        2 * p.x * p.y   + 0.5 * sin(p.x * p.y)
  );
}*/

Point F(Point p) {
  return new Point( 
        0.2 * p.x * p.x + 2 * p.y + 3.0/10.0*sin(p.x*p.y),
        0.25 * p.x + p.x*p.y - cos(p.x)*cos(p.x) + cos(p.y)
  );
}



boolean is_visible(Point p) {
  return p.x<=max_x && p.x>=min_x && p.y<=max_y && p.y>=min_y;
}

Point to_logic(Point p) {
  return new Point(p.x/w * (abs(max_x-min_x)) + min_x, -1.0 * p.y/h *(abs(min_y - max_y)) + max_y);
}

boolean ready = false;

int getColor(float len) {
  if(len<epsilon) {
    return int(len * (float)(1.0/epsilon) * 50); 
  } else if(len<big_epsilon) {
    return int(len * (float)(1.0/big_epsilon) * 150 + 50);
  } 
  else 
    return 255;
}

void draw() {
    loadPixels();
   
    for(int x=0;x<w;x++)
      for(int y=0;y<h;y++) {
        Point p = to_logic(new Point(x,y));
        float inital_len = p.len();
        int i=0;
        for(i=0;i<iterations;i++)
          p=F(p); 
          
        float len = p.len();
        if(len<=inital_len) 
          if(len < big_epsilon) {
            int col = getColor(len);
            pixels[y*h+x] = color(col,col,col);
          }   
      }  
      
      
    updatePixels();

      
  save("foo02.png");

  exit();
  
}

